## organicmaps 2026.01.26-11+ds

=== debian/changelog ===
organicmaps (2026.01.26-11+ds-4) unstable; urgency=medium

  * Build with RELEASE set

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 11 Feb 2026 11:14:08 +0100

organicmaps (2026.01.26-11+ds-3) unstable; urgency=medium

  * Fixed redundant assert (Closes: #1127397)
  * Removed thread checker that fails when searching in Download dialog
    (Closes: #1127396)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 09 Feb 2026 18:12:06 +0100

organicmaps (2026.01.26-11+ds-2) unstable; urgency=medium

  * Check if region's info contains triangles.

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 07 Feb 2026 17:40:15 +0100

organicmaps (2026.01.26-11+ds-1) unstable; urgency=medium

  * Use uscan v5
  * Update Files-Excluded in d/copyright
  * New upstream version 2026.01.26-11+ds
  * Update d/patches
  * Fix d/rules
  * Update d/clean
  * Install DATA_LICENSE.txt
  * Update d/copyright
  * Drop R³
  * Drop optional priority
  * Mark organicmaps-data Multi-Arch: foreign
  * Bump policy version (no changes)
  * Update build dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 06 Feb 2026 11:10:24 +0100
