=== debian/control ===
Source: organicmaps
Section: x11
Maintainer: Federico Ceratto <federico@debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libagg2-dev,
 libboost-dev,
 libexpat1-dev,
 libfast-float-dev,
 libfastobj-dev,
 libflathashmap-dev,
 libfreetype-dev,
 libgflags-dev,
 libglaze-dev,
 libglm-dev,
 libgmock-dev,
 libharfbuzz-dev,
 libicu-dev,
 libjansson-dev,
 libkdtree++-dev,
 libminizip-dev,
 libprotobuf-dev,
 libpugixml-dev,
 libqt6svg6,
 libstb-dev,
 libutfcpp-dev,
 optipng,
 protobuf-compiler,
 python3-mapcss,
 python3-protobuf,
 qt6-base-dev,
 qt6-positioning-dev,
 qt6-svg-dev,
 curl <!nocheck>,
 xauth,
 xvfb,
Standards-Version: 4.7.3
Homepage: https://organicmaps.app/
Vcs-Browser: https://salsa.debian.org/debian/organicmaps
Vcs-Git: https://salsa.debian.org/debian/organicmaps.git
Description: offline maps with routing ability
 Organic Maps is a map application for travelers, tourists, hikers,
 and cyclists based on top of crowd-sourced OpenStreetMap data.
 It is privacy-focused and can be used without an Internet connection.
 It provides navigation for pedestrians, public transport, cycling
 and driving.

Package: organicmaps
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 organicmaps-data,
Description: ${source:Synopsis} (executable)
 ${source:Extended-Description}
 .
 This package contains the OMaps executable.

Package: organicmaps-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} (data)
 ${source:Extended-Description}
 .
 This package contains architecture independent data.
