=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND = -DRELEASE

%:
	dh $@

execute_before_dh_auto_configure:
	tools/unix/generate_proto.sh
	tools/unix/generate_drules.sh

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_SYSTEM_PROVIDED_3PARTY=ON

execute_after_dh_auto_build:
	HOME=/tmp obj-$(DEB_HOST_GNU_TYPE)/generator_tool -generate_packed_borders
	xvfb-run tools/unix/generate_symbols.sh
